#ifndef _H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix__H_
#define _H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "gps_msgs/msg/dds_opensplice/GPSStatus_.h"


namespace gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace GPSFix_Constants
            {
                const ::DDS::Octet COVARIANCE_TYPE_UNKNOWN_ = 0;

                const ::DDS::Octet COVARIANCE_TYPE_APPROXIMATED_ = 1;

                const ::DDS::Octet COVARIANCE_TYPE_DIAGONAL_KNOWN_ = 2;

                const ::DDS::Octet COVARIANCE_TYPE_KNOWN_ = 3;

            }

            struct  GPSFix_
            {
                struct _position_covariance__uniq_{};
                typedef ::DDS::Double _position_covariance__slice;
                typedef ::DDS::Double _position_covariance_[9];
                typedef DDS_DCPS_FArray_var< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__var;
                typedef _position_covariance_ _position_covariance__out;
                typedef DDS_DCPS_Array_forany< _position_covariance_, _position_covariance__slice, struct _position_covariance__uniq_ > _position_covariance__forany;
                static _position_covariance__slice *_position_covariance__alloc();
                static void _position_covariance__free(_position_covariance__slice *);
                static void _position_covariance__copy(_position_covariance__slice *to, const _position_covariance__slice *from);
                static _position_covariance__slice *_position_covariance__dup(const _position_covariance__slice *from);
                ::std_msgs::msg::dds_::Header_ header_;
                ::gps_msgs::msg::dds_::GPSStatus_ status_;
                ::DDS::Double latitude_;
                ::DDS::Double longitude_;
                ::DDS::Double altitude_;
                ::DDS::Double track_;
                ::DDS::Double speed_;
                ::DDS::Double climb_;
                ::DDS::Double pitch_;
                ::DDS::Double roll_;
                ::DDS::Double dip_;
                ::DDS::Double time_;
                ::DDS::Double gdop_;
                ::DDS::Double pdop_;
                ::DDS::Double hdop_;
                ::DDS::Double vdop_;
                ::DDS::Double tdop_;
                ::DDS::Double err_;
                ::DDS::Double err_horz_;
                ::DDS::Double err_vert_;
                ::DDS::Double err_track_;
                ::DDS::Double err_speed_;
                ::DDS::Double err_climb_;
                ::DDS::Double err_time_;
                ::DDS::Double err_pitch_;
                ::DDS::Double err_roll_;
                ::DDS::Double err_dip_;
                _position_covariance_ position_covariance_;
                ::DDS::Octet position_covariance_type_;
            };

            typedef DDS_DCPSStruct_var<GPSFix_> GPSFix__var;
            typedef DDS_DCPSStruct_out < GPSFix_> GPSFix__out;

        }

    }

}

#endif /* _H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix__H_ */
