#ifndef _H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix_DCPS_H_
#define _H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GPSFix_.h"


namespace gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GPSFix_TypeSupportInterface;

            typedef GPSFix_TypeSupportInterface * GPSFix_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GPSFix_TypeSupportInterface> GPSFix_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GPSFix_TypeSupportInterface> GPSFix_TypeSupportInterface_out;


            class GPSFix_DataWriter;

            typedef GPSFix_DataWriter * GPSFix_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GPSFix_DataWriter> GPSFix_DataWriter_var;
            typedef DDS_DCPSInterface_out < GPSFix_DataWriter> GPSFix_DataWriter_out;


            class GPSFix_DataReader;

            typedef GPSFix_DataReader * GPSFix_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GPSFix_DataReader> GPSFix_DataReader_var;
            typedef DDS_DCPSInterface_out < GPSFix_DataReader> GPSFix_DataReader_out;


            class GPSFix_DataReaderView;

            typedef GPSFix_DataReaderView * GPSFix_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GPSFix_DataReaderView> GPSFix_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GPSFix_DataReaderView> GPSFix_DataReaderView_out;

            struct GPSFix_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GPSFix_, struct GPSFix_Seq_uniq_> GPSFix_Seq;
            typedef DDS_DCPSSequence_var < GPSFix_Seq> GPSFix_Seq_var;
            typedef DDS_DCPSSequence_out < GPSFix_Seq> GPSFix_Seq_out;

            class  GPSFix_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GPSFix_TypeSupportInterface_ptr _ptr_type;
                typedef GPSFix_TypeSupportInterface_var _var_type;

                static GPSFix_TypeSupportInterface_ptr _duplicate (GPSFix_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GPSFix_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GPSFix_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GPSFix_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GPSFix_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GPSFix_TypeSupportInterface () {};
                ~GPSFix_TypeSupportInterface () {};
            private:
                GPSFix_TypeSupportInterface (const GPSFix_TypeSupportInterface &);
                GPSFix_TypeSupportInterface & operator = (const GPSFix_TypeSupportInterface &);
            };

            class  GPSFix_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GPSFix_DataWriter_ptr _ptr_type;
                typedef GPSFix_DataWriter_var _var_type;

                static GPSFix_DataWriter_ptr _duplicate (GPSFix_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GPSFix_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GPSFix_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GPSFix_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GPSFix_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GPSFix_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GPSFix_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GPSFix_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GPSFix_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GPSFix_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GPSFix_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GPSFix_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GPSFix_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GPSFix_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GPSFix_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GPSFix_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GPSFix_& instance_data) = 0;

            protected:
                GPSFix_DataWriter () {};
                ~GPSFix_DataWriter () {};
            private:
                GPSFix_DataWriter (const GPSFix_DataWriter &);
                GPSFix_DataWriter & operator = (const GPSFix_DataWriter &);
            };

            class  GPSFix_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GPSFix_DataReader_ptr _ptr_type;
                typedef GPSFix_DataReader_var _var_type;

                static GPSFix_DataReader_ptr _duplicate (GPSFix_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GPSFix_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GPSFix_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GPSFix_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GPSFix_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GPSFix_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GPSFix_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GPSFix_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GPSFix_& instance) = 0;

            protected:
                GPSFix_DataReader () {};
                ~GPSFix_DataReader () {};
            private:
                GPSFix_DataReader (const GPSFix_DataReader &);
                GPSFix_DataReader & operator = (const GPSFix_DataReader &);
            };

            class  GPSFix_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GPSFix_DataReaderView_ptr _ptr_type;
                typedef GPSFix_DataReaderView_var _var_type;

                static GPSFix_DataReaderView_ptr _duplicate (GPSFix_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GPSFix_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GPSFix_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GPSFix_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GPSFix_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GPSFix_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GPSFix_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GPSFix_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GPSFix_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GPSFix_& instance) = 0;

            protected:
                GPSFix_DataReaderView () {};
                ~GPSFix_DataReaderView () {};
            private:
                GPSFix_DataReaderView (const GPSFix_DataReaderView &);
                GPSFix_DataReaderView & operator = (const GPSFix_DataReaderView &);
            };
        }

    }

}

#endif
