#ifndef _H_DA793E161CC5C90ACC35A9E590E10D3F_GPSStatus__H_
#define _H_DA793E161CC5C90ACC35A9E590E10D3F_GPSStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace gps_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace GPSStatus_Constants
            {
                const ::DDS::Short STATUS_NO_FIX_ = (-1);

                const ::DDS::Short STATUS_FIX_ = 0;

                const ::DDS::Short STATUS_SBAS_FIX_ = 1;

                const ::DDS::Short STATUS_GBAS_FIX_ = 2;

                const ::DDS::Short STATUS_DGPS_FIX_ = 18;

                const ::DDS::Short STATUS_WAAS_FIX_ = 33;

                const ::DDS::UShort SOURCE_NONE_ = 0U;

                const ::DDS::UShort SOURCE_GPS_ = 1U;

                const ::DDS::UShort SOURCE_POINTS_ = 2U;

                const ::DDS::UShort SOURCE_DOPPLER_ = 4U;

                const ::DDS::UShort SOURCE_ALTIMETER_ = 8U;

                const ::DDS::UShort SOURCE_MAGNETIC_ = 16U;

                const ::DDS::UShort SOURCE_GYRO_ = 32U;

                const ::DDS::UShort SOURCE_ACCEL_ = 64U;

            }

            struct  GPSStatus_
            {
                struct _satellite_used_prn__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _satellite_used_prn__seq_uniq_ > _satellite_used_prn__seq;
                typedef DDS_DCPSSequence_var< _satellite_used_prn__seq > _satellite_used_prn__seq_var;
                typedef DDS_DCPSSequence_out< _satellite_used_prn__seq > _satellite_used_prn__seq_out;
                struct _satellite_visible_prn__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _satellite_visible_prn__seq_uniq_ > _satellite_visible_prn__seq;
                typedef DDS_DCPSSequence_var< _satellite_visible_prn__seq > _satellite_visible_prn__seq_var;
                typedef DDS_DCPSSequence_out< _satellite_visible_prn__seq > _satellite_visible_prn__seq_out;
                struct _satellite_visible_z__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _satellite_visible_z__seq_uniq_ > _satellite_visible_z__seq;
                typedef DDS_DCPSSequence_var< _satellite_visible_z__seq > _satellite_visible_z__seq_var;
                typedef DDS_DCPSSequence_out< _satellite_visible_z__seq > _satellite_visible_z__seq_out;
                struct _satellite_visible_azimuth__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _satellite_visible_azimuth__seq_uniq_ > _satellite_visible_azimuth__seq;
                typedef DDS_DCPSSequence_var< _satellite_visible_azimuth__seq > _satellite_visible_azimuth__seq_var;
                typedef DDS_DCPSSequence_out< _satellite_visible_azimuth__seq > _satellite_visible_azimuth__seq_out;
                struct _satellite_visible_snr__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Long, struct _satellite_visible_snr__seq_uniq_ > _satellite_visible_snr__seq;
                typedef DDS_DCPSSequence_var< _satellite_visible_snr__seq > _satellite_visible_snr__seq_var;
                typedef DDS_DCPSSequence_out< _satellite_visible_snr__seq > _satellite_visible_snr__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort satellites_used_;
                _satellite_used_prn__seq satellite_used_prn_;
                ::DDS::UShort satellites_visible_;
                _satellite_visible_prn__seq satellite_visible_prn_;
                _satellite_visible_z__seq satellite_visible_z_;
                _satellite_visible_azimuth__seq satellite_visible_azimuth_;
                _satellite_visible_snr__seq satellite_visible_snr_;
                ::DDS::Short status_;
                ::DDS::UShort motion_source_;
                ::DDS::UShort orientation_source_;
                ::DDS::UShort position_source_;
            };

            typedef DDS_DCPSStruct_var<GPSStatus_> GPSStatus__var;
            typedef DDS_DCPSStruct_out < GPSStatus_> GPSStatus__out;

        }

    }

}

#endif /* _H_DA793E161CC5C90ACC35A9E590E10D3F_GPSStatus__H_ */
